/**
 * 
 */
package de.mcs.tools.sps.emulator.emulator.holtek;

import de.mcs.tools.sps.emulator.EmulatorOutput;

/**
 * @author w.klaas
 *
 */
public class HoltekEmulatorOutput implements EmulatorOutput {

  boolean d0, d1, d2, d3;
  int pwm;

  @Override
  public void reset() {
    d0 = false;
    d1 = false;
    d2 = false;
    d3 = false;
    pwm = 0;
  }

  @Override
  public void setOutput(byte data) {
    d0 = (data & (byte) 0x01) > 0;
    d1 = (data & (byte) 0x02) > 0;
    d2 = (data & (byte) 0x04) > 0;
    d3 = (data & (byte) 0x08) > 0;
  }

  @Override
  public byte getOutput() {
    return (byte) ((d0 ? 1 : 0) + (d1 ? 2 : 0) + (d2 ? 4 : 0) + (d3 ? 8 : 0));
  }

  @Override
  public void setFeature(String name, byte register) {
    if ("PWM".equals(name.toUpperCase())) {
      pwm = register;
    }
  }

  @Override
  public byte getFeature(String name) {
    if ("PWM".equals(name.toUpperCase())) {
      return (byte) pwm;
    }
    return 0;
  }
}
